﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace ScriptEditor
{
    public partial class Form1 : Form
    {
        const string deftitle = "Script Editor";
        string sdbfile = String.Empty;
        string mfile = String.Empty;
        public Form1()
        {
            InitializeComponent();
            NewFile();
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            mfile = String.Empty;
            OpenFileDialog mfileOpenDialog = new OpenFileDialog();
            mfileOpenDialog.Filter = "*.m|*.m";
            mfileOpenDialog.CheckFileExists = true;
            mfileOpenDialog.Multiselect = false;
            mfileOpenDialog.FileOk += new CancelEventHandler(mfileOpenDialog_FileOk);
            mfileOpenDialog.ShowDialog();
            if (mfile != String.Empty)
                DecompileScript(mfile);
        }

        void mfileOpenDialog_FileOk(object sender, CancelEventArgs e)
        {
            mfile = (sender as OpenFileDialog).FileName;
            this.Text = deftitle + " - " + Path.GetFileName(mfile);

            if (sdbfile == String.Empty)
            {
                if (File.Exists(Path.Combine(Path.GetDirectoryName(mfile), "sdb.txt")))
                    sdbfile = Path.Combine(Path.GetDirectoryName(mfile), "sdb.txt");
                else
                {
                    OpenFileDialog sdbfileOpenDialog = new OpenFileDialog();
                    sdbfileOpenDialog.Filter = "sdb.txt|sdb.txt";
                    sdbfileOpenDialog.CheckFileExists = true;
                    sdbfileOpenDialog.Multiselect = false;
                    sdbfileOpenDialog.FileOk += new CancelEventHandler(sdbfileOpenDialog_FileOk);
                    sdbfileOpenDialog.ShowDialog();
                }
            }
            SDB.InitSDB(sdbfile);
        }

        void sdbfileOpenDialog_FileOk(object sender, CancelEventArgs e)
        {
            sdbfile = (sender as OpenFileDialog).FileName;
        }

        void DecompileScript(string filename)
        {
            richTextBox1.Text = ScriptDecompile.Decompile(filename);
        }

        private void compileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog savedialog = new SaveFileDialog();
            savedialog.DefaultExt = ".m";
            savedialog.FileOk += new CancelEventHandler(savedialog_FileOk);
            if (mfile != String.Empty)
                savedialog.FileName = Path.GetFileName(mfile);
            savedialog.ShowDialog();
        }

        void savedialog_FileOk(object sender, CancelEventArgs e)
        {
            if (sdbfile == String.Empty)
            {
                if (File.Exists(Path.Combine(Path.GetDirectoryName((sender as SaveFileDialog).FileName), "sdb.txt")))
                    sdbfile = Path.Combine(Path.GetDirectoryName((sender as SaveFileDialog).FileName), "sdb.txt");
                else
                {
                    OpenFileDialog sdbfileOpenDialog = new OpenFileDialog();
                    sdbfileOpenDialog.Filter = "sdb.txt|sdb.txt";
                    sdbfileOpenDialog.CheckFileExists = true;
                    sdbfileOpenDialog.Multiselect = false;
                    sdbfileOpenDialog.FileOk += new CancelEventHandler(sdbfileOpenDialog_FileOk);
                    sdbfileOpenDialog.ShowDialog();
                }
                SDB.InitSDB(sdbfile);
            }
            ScriptCompile.Compile(richTextBox1.Text, (sender as SaveFileDialog).FileName);
            mfile = (sender as SaveFileDialog).FileName;
            this.Text = deftitle + " - " + Path.GetFileName((sender as SaveFileDialog).FileName);
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
            NewFile();
        }

        private void NewFile()
        {
            mfile = String.Empty;
            this.Text = deftitle + " - New";
            richTextBox1.Text = String.Empty;
        }

        private void richTextBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Control && e.KeyValue == 86)
            {
                richTextBox1.Paste(DataFormats.GetFormat(DataFormats.UnicodeText));
                e.Handled = true;
            }
        }
    }
}
